# coding: utf-8

"""
    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class SignUserTransactionRequest(BaseModel):
    """
    SignUserTransactionRequest
    """
    wallet_id: StrictStr = Field(..., alias="walletId", description="System-generated unique identifier of the resource.")
    raw_transaction: Optional[StrictStr] = Field(None, alias="rawTransaction", description="Raw transaction string that needs to be signed. Excluded with `transaction`. Required without `transaction`. Required to be base64 encoded for NEAR, Solana chains. Required to be hex encoded for EVM chains. ")
    transaction: Optional[StrictStr] = Field(None, description="Transaction object in JSON that needs to be signed. Excluded with `rawTransaction`. Required without `rawTransaction`.  NOTE: This field is only supported by `EVM` chains. ")
    memo: Optional[StrictStr] = Field(None, description="The human readable explanation for this sign action. Useful for presenting with extra information.")
    __properties = ["walletId", "rawTransaction", "transaction", "memo"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SignUserTransactionRequest:
        """Create an instance of SignUserTransactionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SignUserTransactionRequest:
        """Create an instance of SignUserTransactionRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SignUserTransactionRequest.parse_obj(obj)

        _obj = SignUserTransactionRequest.parse_obj({
            "wallet_id": obj.get("walletId"),
            "raw_transaction": obj.get("rawTransaction"),
            "transaction": obj.get("transaction"),
            "memo": obj.get("memo")
        })
        return _obj


